This document describes the Changelog store workflow.

Contents:
    1) Feature description;
    2) CL store commands description;
    3) CL workflow.

1) Feature description:

    Changelog store is designed to track support incremental backup process
    storing on disk to be able to keep changed blocks consistent after reboot.
    The result of feature work is consistent incremental snapshots from the
    device across reboot.

2) CL store command description:

    - bsctl --attach-to-device <dev/sdXX>
           Start tracking changed data via RAM-store.

    - bsctl --create-chlog-store </dev/sdXX> - 
           Create on-disk storage for changelog (like /.blksnap/changelog);

    - bsctl --map-chlog-store </dev/sdXX> - 
           Enable recording of tracked data to disk;

    - bsctl --check-chlog-store </dev/sdXX> - 
           Check integrity of changelog file stored on protected device;

    - bsctl --reset-chlog-store </dev/sdXX> - 
            Set current changelog state to zero. Next snapshot will be base.

3) CL Workflow. 

    - Attaching new device to blk-snapshot module:

        - attach device to blk-snapshot;
        
        - mount device to file structure;

        - create cl-store using --create-chlog-store command to allocate disk
          space for changelog;

        - map cl-store using --map-chlog-store to start IO tracking. After the
          first mapping - device status is dirty. This means that the next
          snapshot will be base;

        - take base snapshot. After successfull snapshot ending volume status
          should change from Dirty = Yes to Dirty = No. This mean that cl-store
          is consistent and next snapshot will be incremental.

   - Steps before rebooting the machine:

        - umount protected device from dir tree;

        - detach device from blk-snapshot

        - reboot

    - Attaching device during boot process:

        - attach device to blk-snapshot;

        -  mount it to dir structure;

        - check cl-store using --check-chlog-store command. If check was failed
          then data corruption or volume resize tool place. In this case
          cl-store should be recreated and next snap should be based;

        - map metadata store to ensure that device haven't been changed after
          detach;

        - map cl-store using command --map-chlog-store. If map is ok and
          metadata store was also successful then volume will have status
          Dirty = No and next snapshot will be incremental.
