#ifndef _BLKSNAP_FS_TYPES_H
#define _BLKSNAP_FS_TYPES_H

#define BLKSNAP_UNSUPPORTED_FS_TYPES_FILE "/.blksnap/unsupported-fs-types"

struct blksnap_fs {
	const char *name;
	enum blksnap_fs_type fs_type;
};

static struct blksnap_fs blksnap_fs_types[] = {
	{ .name = "ext2",	.fs_type = BLKSNAP_FS_EXT2 },
	{ .name = "ext3",	.fs_type = BLKSNAP_FS_EXT3 },
	{ .name = "ext4",	.fs_type = BLKSNAP_FS_EXT4 },
	{ .name = "xfs",	.fs_type = BLKSNAP_FS_XFS },
	{ .name = "btrfs",	.fs_type = BLKSNAP_FS_BTRFS },
	{ .name = "vfat",	.fs_type = BLKSNAP_FS_VFAT },
	{ .name = "unknown",	.fs_type = BLKSNAP_FS_UNKNOWN },
};

static const char *fstype_to_string(enum blksnap_fs_type fs_type)
{
	int fs_idx;
	static char *unknown = "unknown";
	const char *ret = unknown;

	for (fs_idx = 0;
	     fs_idx < (int)(sizeof(blksnap_fs_types) / sizeof(struct blksnap_fs));
	     fs_idx++) {
		if (fs_type == blksnap_fs_types[fs_idx].fs_type) {
			ret = blksnap_fs_types[fs_idx].name;
			break;
		}
	}
	return ret;
}

#endif /* _BLKSNAP_FS_TYPES_H */

