#ifndef _BLKSNAP_BIO_QUEUE_SHARE_H
#define _BLKSNAP_BIO_QUEUE_SHARE_H

#include <linux/kthread.h>

struct blksnap_bio_queue;
typedef void (*flush_func_t)(struct blksnap_bio_queue *bq);

struct blksnap_volume;

struct blksnap_bio_queue {
	/* Used to protect the thread's queue */
	spinlock_t lock;

	/* Thread's work queue */
	struct bio_list bios;

	/* Used to awake the thread when work is to be done */
	wait_queue_head_t event;

	/* Kernel thread to submit bios */
	struct task_struct *task;

	/* Reverse reference to blksnap volume to get back
	 * make_request fn
	 */
	struct blksnap_volume *volume;

	/* flush bio callbacks */
	flush_func_t flush;
};

#endif /* _BLKNSAP_BIO_QUEUE_SHARE_H */

