#ifndef _BLKSNAP_BIO_SUBMIT_H
#define _BLKSNAP_BIO_SUBMIT_H

#include <linux/bio.h>
#include <linux/blk_types.h>

#include "blksnap-compat.h"

enum BLKSNAP_IO_OP {
	BLKSNAP_READ,
	BLKSNAP_WRITE,
	/* don't add bio blocks to changelog and don't create CoW */
	BLKSNAP_WRITE_FILTER_DISABLED
};

BIO_ENDIO_TYPE blksnap_bio_complete_passby(BIO_ENDIO_PARAMS);
BIO_ENDIO_TYPE blksnap_bio_complete_filtered(BIO_ENDIO_PARAMS);

static inline bool blksnap_owns_bio(struct bio *bio)
{
	return (bio->bi_end_io == &blksnap_bio_complete_passby);
}

/* public interface for submit bio with completion wait */
int blksnap_submit_bio_wait(struct bio *bio, int op);

#endif /* _BLKSNAP_BIO_SUBMIT_H */
