#ifndef _BLKSNAP_BLOCK_H
#define _BLKSNAP_BLOCK_H

/* Convert absolute (from device start) sector offset to bitmap index */
void abs_addr_to_index(struct blksnap_volume *volume, sector_t abs_sectors,
		       struct blksnap_bitmap_iter *index);

int block_test_bit(struct blksnap_volume *volume, sector_t addr, u8 bit);

int block_set_bit(struct blksnap_volume *volume, sector_t addr, u8 bit);

int block_test_and_set_bit(struct blksnap_volume *volume,
			   sector_t addr, u8 bit, bool *res);

bool __block_test_and_set_bit(struct blksnap_volume *volume,
			      struct blksnap_bitmap_iter *index,
			      u8 bit);

bool block_is_active(struct blksnap_volume *volume, sector_t addr);

void block_clear_bit(struct blksnap_volume *volume, sector_t addr, u8 bit);

void __block_reset(struct blksnap_volume *volume, struct blksnap_bitmap_iter *index);

#endif /* _BLKSNAP_BLOCK_H */
