#ifndef _BLKSNAP_CL_THREAD_H_
#define _BLKSNAP_CL_THREAD_H_

#include <linux/fs.h>

#include "blksnap-cl-buffer.h"

struct cl_thread;

struct cl_thread_opts
{
	void (*invalidate_cb)(void *data);
	void *invalidate_data;
	writer_func writer_cb;
	void *writer_cb_data;
};

int blksnap_cl_cmd_cache_create(void);

void blksnap_cl_cmd_cache_destroy(void);

struct cl_thread *blksnap_cl_thread_init(struct cl_thread_opts *options,
					 struct block_device *bdev);
void blksnap_cl_thread_destroy(struct cl_thread *thread);

int blksnap_cl_thread_add_block(struct cl_thread *thread, sector_t addr);

#endif /*_BLKSNAP_CL_THREAD_H_ */
