#ifndef _BLKSNAP_METADATA_H
#define _BLKSNAP_METADATA_H

#include "blksnap-device.h"
#include "blksnap-extent.h"

/* store current metadata without update */
#define BLKSNAP_META_STORE      0
/* sync metadata with current volume and then store it */
#define BLKSNAP_META_UPDATE     1
/* reset metadata so it will not be valid next time it is mapped */
#define BLKSNAP_META_RESET      2

bool hash_sums_equals(__u32 left[], __u32 right[]);

int get_blocks_hash(struct block_device *bdev,
		    struct blksnap_metadata *metadata);

int process_metadata(struct block_device *device,
		     struct blksnap_metadata *metadata,
		     struct blksnap_meta_on_disk *data, int op);

int update_metadata(struct blksnap_volume *volume, int mode);

#endif /* _BLKSNAP_METADATA_H */
