#ifndef _BLKSNAP_RBTREE_FOREACH_H
#define _BLKSNAP_RBTREE_FOREACH_H

#include <linux/rbtree.h>

#define rb_entry_chk(ptr, type, field) \
	(((ptr)) ? rb_entry(ptr, type, field) : NULL)

#define rbtree_safe_to_remove_foreach(pos, next_pos, root, field) \
	for(pos = rb_entry_chk(rb_first(root), typeof(*pos), field); \
	    pos && ({ next_pos = rb_entry_chk(rb_next(&pos->field), \
					      typeof(*pos), field); 1; }); \
	    pos = next_pos)

#endif /* _BLKSNAP_RBTREE_FOREACH_H */

