#ifndef _BLKSNAP_SNAPSHOT_H
#define _BLKSNAP_SNAPSHOT_H

#include <linux/blkdev.h>

#include "blksnap-device.h"

extern struct block_device_operations snapshot_ops;
extern int blksnap_major;

static inline char *blksnap_snapshot_name(struct blksnap_volume *volume)
{
	BUG_ON(!volume);

	if (volume->disk && volume->disk->disk_name)
		return volume->disk->disk_name;
	return UNKNOWN_NAME;
}

int start_snapshot(struct blksnap_volume *volume,
		   struct blksnap_ioctl_start *start);

int stop_snapshot(struct blksnap_volume *volume, bool merge);

void copy_write_bio(struct blksnap_volume *volume, struct bio *bio);
void record_write_bio(struct blksnap_volume *volume, struct bio *bio);

#endif /* _BLKSNAP_SNAPSHOT_H */

