#ifndef _BLKSNAP_WRITE_QUEUE_H
#define _BLKSNAP_WRITE_QUEUE_H

#include "blksnap-bio-queue.h"

unsigned int blksnap_write_bio_kthread_init(struct blksnap_volume *volume);

static inline void
blksnap_write_bio_kthread_destroy(struct blksnap_volume *volume) {
	blksnap_bio_kthread_destroy(&volume->write_queue);
}

static inline void
blksnap_write_bio_enqueue(struct blksnap_volume *volume, struct bio *bio) {
	blksnap_bio_kthread_enqueue(&volume->write_queue, bio);
}

static inline void blksnap_write_wake_up(struct blksnap_volume *volume) {
	BUG_ON(!volume);

	wake_up(&volume->write_queue.event);
}

#endif /* _BLKNSAP_WRITE_QUEUE_H */

