#include <linux/module.h>
#include "blksnap-test.h"

unsigned int tests_run = 0;
unsigned int tests_ok = 0;

static test_ret_t all_tests(void);

static int __init test_init(void)
{
	test_ret_t result;

	mu_print("Start Unit Tests");

	result = all_tests();

	if (result == 0)
		mu_print("OK");

	mu_print("%d %s. %d OK. %d FAIL.",
		 tests_run, tests_run > 1 ? "TESTS" : "TEST",
		 tests_ok, tests_run - tests_ok);

	return result == 0 ? TESTS_SUCCESS: TESTS_FAILED;
}

static void __exit test_exit(void)
{
}

module_init(test_init);
module_exit(test_exit);
