#!/bin/bash

INSMOD=$(which insmod)
INSMOD=${INSMOD:-"/sbin/insmod"}

RMMOD=$(which rmmod)
RMMOD=${RMMOD:-"/sbin/rmmod"}

retval=0
echo "----------  Starting unit testing ---------";
for test in *.ko; do
	sudo $INSMOD $test;
	if [ $? != 0 ]; then
		retval=1
		echo "Test $test failed. See dmesg for information!";
	else
		sudo $RMMOD $test;
		echo "Test $test passed successfully!";
	fi;
done;
echo "----------  End unit testing --------------";
exit $retval
