#!/bin/bash

# Configure these parameters!!!
DEV=/dev/md0
MNT=/tmp/md0
# Name of .tgz archive
LKM=blk-release-6.1.2
# LKM=blk-develop
# FileSize to write before snapshot (mB)
FSIZE=6900
# FileSize to write ob snapshot (mB)
COWSIZE=1500

# Preconfigured parameters. Not needed to be changed
WRT_BEFORE=/tmp/write.before
WRT_AFTER=/tmp/write.after
COW_BEFORE=/tmp/cow.before
COW_AFTER=/tmp/cow.after

LKM_DIR=blk-snapshot
MOD="$PWD/$LKM_DIR/blk-snapshot.ko"
BSCTL="$PWD/$LKM_DIR/bsctl"

function fail {
  echo "FAIL ($2)"
  sudo rmmod $MOD &>/dev/null
  exit $1
}

function store_memory_usage {
  cat /proc/meminfo | head -n 4 >$1
}

function compare_show_mem {
   TOTAL=$(cat $1 | grep ^MemTotal: | awk '{print $2}')
   MEMFREE1=$(cat $1 | grep ^MemFree: | awk '{print $2}')
   BUFFERS1=$(cat $1 | grep ^Buffers: | awk '{print $2}')
   CACHED1=$(cat $1 | grep ^Cached: | awk '{print $2}')
   MEMFREE2=$(cat $2 | grep ^MemFree: | awk '{print $2}')
   BUFFERS2=$(cat $2 | grep ^Buffers: | awk '{print $2}')
   CACHED2=$(cat $2 | grep ^Cached: | awk '{print $2}')

   USED1=$(($TOTAL - $MEMFREE1 - $BUFFERS1 - $CACHED1))
   USED2=$(($TOTAL - $MEMFREE2 - $BUFFERS2 - $CACHED2))

   echo "Used memory before : $USED1 kB ($TOTAL - $MEMFREE1 - $BUFFERS1 - $CACHED1)"
   echo "Used memory after  : $USED2 kB ($TOTAL - $MEMFREE2 - $BUFFERS2 - $CACHED2)"
   echo "Used memory compare: $(($USED2 - $USED1)) kB"
}

