#!/bin/bash

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
. $DIR/mem-test-lib.sh

echo Run Stage1 of memory compare test...

echo -n Make $DEV not dirty...
sudo $BSCTL -s $DEV &>/dev/null || fail $? "Can't start snapshot on \"$DEV\""
while ! sudo $BSCTL -e $DEV &>/dev/null; do
    sleep 1; echo -n .
done
echo OK

echo -n Store initial memory usage...
store_memory_usage $WRT_BEFORE
echo OK

echo -n Write $FSIZE MB to $MNT...
sudo dd if=/dev/zero of=$MNT/test.file bs=1M count=$FSIZE &>/dev/null || fail $? "Can't complete writing file to \"$MNT\""
echo OK

sync

echo -n Store memory usage after write...
store_memory_usage $WRT_AFTER
echo OK

echo Stage1 is competed.

