#!/bin/bash

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
. $DIR/mem-test-lib.sh

echo Run stage2 of memory compare test...

echo -n Store memory usage after write...
store_memory_usage $WRT_AFTER
echo OK

echo -n Start Snapshot $DEV...
sudo $BSCTL -s $DEV &>/dev/null || fail $? "Can't detach \"$DEV\""
echo OK

sync

echo -n Store memory usage before CoW test...
store_memory_usage $COW_BEFORE
echo OK

echo -n Write $COWSIZE MB to $MNT...
sudo dd if=/dev/zero of=$MNT/test.file.cow bs=1M count=$COWSIZE &>/dev/null || fail $? "Can't complete writing file to \"$MNT\""
echo OK

sync

echo -n Store memory usage after CoW test...
store_memory_usage $COW_AFTER
echo OK

echo -n Stop Snapshot $DEV...
sudo $BSCTL -e $DEV &>/dev/null || fail $? "Can't detach \"$DEV\""
echo OK

sync

echo Test is completed.

echo Write results:
compare_show_mem $WRT_BEFORE $WRT_AFTER

echo CoW results:
compare_show_mem $COW_BEFORE $COW_AFTER

