#include "blksnap-test.h"
#include "blksnap-test.c"


#include "blksnap-bio.h"
#include "blksnap-bio.c"

#include "blksnap-bio-queue.h"
#include "blksnap-bio-queue.c"

#include "blksnap-extent.h"
#include "blksnap-extent.c"

#include "blksnap-volume.h"
#include "blksnap-volume.c"

#include "blksnap-data.h"
#include "blksnap-data.c"

#include "blksnap-bitmap.h"
#include "blksnap-bitmap.c"

#include "blksnap-block.h"
#include "blksnap-block.c"

#include "blksnap-bio-submit.h"
#include "blksnap-bio-submit.c"

#include "blksnap-cow-tree.h"
#include "blksnap-cow-tree.c"

#include "blksnap-cl-buffer.h"
#include "blksnap-cl-buffer.c"

#include "blksnap-cl-thread.h"
#include "blksnap-cl-thread.c"

#include "blksnap-cl-store.h"
#include "blksnap-cl-store.c"

#include "blksnap-shared.c"

#define BLOCKS_CNT 	100000
#define BLOCKS_PER_PAGE (PAGE_SIZE / sizeof(uint64_t))
#define TOTAL_PAGE_CNT  (((double) BLOCKS_CNT / (double) BLOCKS_PER_PAGE) + 0.5)

static test_ret_t cl_store_test_init_destroy(void)
{
	gfp_t gfp_mask = GFP_KERNEL;
	struct block_device *bdev;
	struct blksnap_cl_store *store;

	mu_start(__func__);

	bdev = kzalloc(sizeof(*bdev), gfp_mask);
	mu_assert(bdev, "Can't allocate memory");
	bdev->bd_dev = MKDEV(77, 77);

	/* Create cl store */
	store = cl_store_init(bdev);

	mu_assert_not_equal(store, ERR_PTR(-ENOMEM),
			    "Error initializing blksnap_cl_store: no memory");

	/* Destroy */
	cl_store_destroy(store);

	kfree(bdev);

	mu_end(__func__);

	return 0;
}

#if 0
static test_ret_t cl_store_test_high_intencity(void)
{
	gfp_t gfp_mask = GFP_KERNEL;
	struct block_device *bdev;
	struct blksnap_cl_store *store;
	int i;

	mu_start(__func__);

	bdev = kzalloc(sizeof(*bdev), gfp_mask);
	mu_assert(bdev, "Could not allocate memory");
	bdev->bd_dev = MKDEV(77, 77);

	store = cl_store_init(bdev);

	for (i = 0; i < BLOCKS_CNT; i++) {
	}

	cl_store_destroy(store);

	// mu_assert_equal(write_calls, TOTAL_PAGE_CNT, "Error writing blocks");
	// mu_assert_equal(invalid_calls, 0, "Error. CL is invalid");

	kfree(bdev);

	mu_end(__func__);

	return 0;
}

#endif

static test_ret_t all_tests()
{
	mu_run_test(cl_store_test_init_destroy);
	// mu_run_test(cl_store_test_high_intencity);

	return 0;
}

