#ifndef _BSCTL_CHLOG_H
#define _BSCTL_CHLOG_H

#include "blksnap.h"
#include "bsctl-error.h"

typedef int (*chlog_cb) (struct blksnap_ioctl_disk_extent *,
			 unsigned int, void *,
			 struct bsctl_error *err);

unsigned int bsctl_chlog_size(const char *dev_path, struct bsctl_error *err);

struct blksnap_ioctl *bsctl_chlog_get_chunk(uint64_t offset,
					    const char *dev_path,
					    struct bsctl_error *err);

struct changelog_stat *bsctl_chlog_process(const char *dev_path,
					   unsigned int total_blocks,
					   chlog_cb func, void *data,
					   struct bsctl_error *err);
#endif /* _BSCTL_CHLOG_H */
