#ifndef _BSCTL_ERROR_H
#define _BSCTL_ERROR_H

#include <inttypes.h>

#define BSCTL_ERROR_MAX_LEN 256

#define BLKSNAP_ERROR_TO_USER(e) \
	((e) & 0377)

/* external interface to C#, need to know pack value */
/* WARNING for bsctl: do not ever assume that objects <struct bsctl_error *>
 * are allocated!!! */
#pragma pack(push, 1)
struct bsctl_error {
	int32_t  err;
	char msg[BSCTL_ERROR_MAX_LEN];
};
#pragma pack(pop)

int bsctl_error_set(struct bsctl_error *error, int err, const char *fmt, ...);
int bsctl_error_ioctl(struct bsctl_error *error, int err, const char *dev_path);

#define bsctl_err_set(error, err, fmt, ...) \
	bsctl_error_set((error), BLKSNAP_ERROR_TO_USER(err), \
			"ERROR: " fmt, ##__VA_ARGS__)

#define bsctl_err_reset(error) \
	bsctl_error_set((error), 0, "")

#endif /* _BSCTL_ERROR_H */
